#ifndef TACHE_H
#define TACHE_H

#include "outils_numeriques_statiques.h"
#include "type_list.h"

//
// Une tche priodique, version statique. S'il est possible d'avoir deux
// tches ayant la mme priode et le mme temps de calcul, il est possible
// de les distinguer en ajoutant un 3e paramtre descriptif (un identifiant)
//  ce type; je ne l'ai pas fait pour ce petit exemple acadmique
//
class calcul_plus_long_que_periode {};
template <int P, int C> // Periode, temps de Calcul
   struct Tache {
      static_assert(C <= P, "calcul plus long que periode");
   };

//
// Une tche priodique, version dynamique
//
class Tache_ {
public:
   using id_type = int;
private:
   int periode_;
   int calcul_;
   id_type id_;
   static id_type id_cur;
public:
   Tache_(int periode, int calcul) : periode_{ periode }, calcul_{ calcul }, id_{ id_cur++ } {
   }
   id_type id() const {
      return id_;
   }
   int periode() const {
      return periode_;
   }
   int calcul() const {
      return calcul_;
   }
};

#include <iosfwd>
std::ostream& operator<< (std::ostream&, const Tache_&);

//
// extracteurs statiques
//
template <class>
   struct extract_period;
template <int P, int C>
   struct extract_period<Tache<P, C>> : int_<P> {
   };
template <class T>
   using extract_period_t = typename extract_period<T>::type;

template <class>
   struct extract_calcul;
template <int P, int C>
   struct extract_calcul<Tache<P, C>> : int_<C> {
   };
template <class T>
   using extract_calcul_t = typename extract_calcul<T>::type;

class afficher_tache {
   std::ostream &os;
   const char *suffixe;
public:
   afficher_tache(std::ostream &os, const char *suffixe = "") : os{ os }, suffixe{ suffixe } {
   }
   template <class T>
      void operator()(T) {
         os << '(' << extract_period_t<T>::value << ',' << extract_calcul_t<T>::value << ')' << suffixe;
      }
   void operator()(type_list<>) {
   }
};

#endif
