#ifndef ALGORITHM_EXT_H
#define ALGORITHM_EXT_H

#include <functional>
#include <algorithm>
#include <utility>
#include <iterator>

template <class It, class T>
   bool equal_all(It debut, It fin, const T &val) {
      return std::all_of(debut, fin, [&](const auto &candidat) {
         return val == candidat;
      });
   }

template <class It, class D>
void advance_upto(It &p, D n, It end) { // Inefficace
   using namespace std;
   advance(p, min(distance(p, end), n));
}

template <class It>
   class find_stride_impl {
   public:
      using value_type = typename
         std::iterator_traits<It>::value_type;
      using stride_type = typename
         std::iterator_traits<It>::difference_type;
   private:
      It end;
      stride_type n;
      value_type val;
   public:
      find_stride_impl(stride_type n, value_type val, It end) : end{ end }, n{ n }, val{ val } {
      }
      bool operator()(It pos) const {
         using namespace std;
         return distance(pos, end) >= n && equal_all(pos, next(pos, n), val);
      }
   };

template <class It, class D, class V>
   find_stride_impl<It> find_stride(D n, V val, It end) {
      return find_stride_impl<It>(n, val, end);
   }

#endif
