#ifndef RELATION_EQUIVALENCE_H
#define RELATION_EQUIVALENCE_H

#include <iosfwd>

namespace relation {
   //
   // Prsume que E == E est dfini
   //
   template <class E, class ... Parent>
      struct equivalence : Parent... {
         friend bool operator!=(const E &a, const E &b) {
            return !(a == b);
         }
      };
   template <class T>
   class test_equivalence {
      T &a, &b;
   public:
      test_equivalence(T &a, T &b) noexcept : a{ a }, b{ b } {
      }
      friend std::ostream& operator <<(std::ostream &os, test_equivalence &te) {
         if (te.a == te.b)
            os << te.a << " == " << te.b << std::endl;
         if (te.a != te.b)
            os << te.a << " != " << te.b << std::endl;
         return os;
      }
   };
   template <class T>
      test_equivalence<T> CreerTestEquivalence(T &a, T &b) {
         return { a, b };
      }
}

#endif
