#ifndef INTERVALLES_DISCRETS_H
#define INTERVALLES_DISCRETS_H

#include "types_brefs.h"
#include <type_traits>

//
// Appartenance  un intervalle discret
//
template <int N, int SEUIL>
   struct est_plus_petit_que : bool_<(N < SEUIL)> {
   };
template <int N, int SEUIL>
   struct est_plus_petit_egal_que : bool_<!(SEUIL < N)> {
   };
template <int N, int SEUIL>
   struct est_plus_grand_que : bool_<(SEUIL < N)> {
   };
template <int N, int SEUIL>
   struct est_plus_grand_egal_que : bool_<!(N < SEUIL)> {
   };
template <int N, int BORNE_MIN, int BORNE_MAX>
   struct est_dans_inclusif : bool_<(BORNE_MIN <= N && N <= BORNE_MAX)> {
   };
template <int N, int BORNE_MIN, int BORNE_MAX>
   struct est_dans_exclusif : bool_<(BORNE_MIN < N && N < BORNE_MAX)> {
   };
template <int N>
   struct est_positif : bool_<(N >= 0)> {
   };
template <int N>
   struct est_negatif : bool_<(N < 0)> {
   };

//
// fonction de test
//
#include <iosfwd>
template <int A, int B>
   void tester_operateurs_relationnels(std::ostream &os) {
      using namespace std;
      if (est_plus_petit_que<A, B>::value)
         os << A << " < " << B << endl;
      if (est_plus_petit_egal_que<A, B>::value)
         os << A << " <= " << B << endl;
      if (est_plus_grand_que<A, B>::value)
         os << A << " > " << B << endl;
      if (est_plus_grand_egal_que<A, B>::value)
         os << A << " >= " << B << endl;
   }

#endif
